Debian Bug report logs - #583756
desktopnova: circular dependency with desktopnova-module-gnome|desktopnova-module-xfce

version graph

Package: desktopnova; Maintainer for desktopnova is Stefan Haller <haliner@googlemail.com>; Source for desktopnova is src:desktopnova.

Reported by: Bill Allombert <ballombe@debian.org>

Date: Sun, 30 May 2010 12:51:06 UTC

Severity: important

Found in version desktopnova/0.8-1

Fixed in version desktopnova/0.8-2

Done: Stefan Haller <haliner@googlemail.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Stefan Haller <haliner@googlemail.com>:
Bug#583756; Package desktopnova. (Sun, 30 May 2010 12:51:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <ballombe@debian.org>:
New Bug report received and forwarded. Copy sent to Stefan Haller <haliner@googlemail.com>. (Sun, 30 May 2010 12:51:09 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Bill Allombert <ballombe@debian.org>
To: submit@bugs.debian.org
Subject: desktopnova: circular dependency with desktopnova-module-gnome|desktopnova-module-xfce
Date: Sun, 30 May 2010 14:50:36 +0200
Package: desktopnova
Version: 0.8-1
Severity: important

Hello Stefan,

There is a circular dependency between desktopnova, desktopnova-module-gnome and desktopnova-module-xfce:

desktopnova 	:Depends: desktopnova-module-gnome | desktopnova-module-xfce
desktopnova-module-gnome 	:Depends: desktopnova (= 0.8-1)
desktopnova-module-xfce 	:Depends: desktopnova (= 0.8-1)

Circular dependencies, especially with exact version requirement are known to
cause problems during upgrade, so we should try to get rid of them.

See threads 
http://lists.debian.org/debian-devel/2005/06/msg02111.html
http://lists.debian.org/debian-devel/2005/11/msg01101.html

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#583756; Package desktopnova. (Sun, 30 May 2010 14:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stefan Haller <haliner@googlemail.com>:
Extra info received and forwarded to list. (Sun, 30 May 2010 14:03:07 GMT) Full text and rfc822 format available.

Message #10 received at 583756@bugs.debian.org (full text, mbox):

From: Stefan Haller <haliner@googlemail.com>
To: Bill Allombert <ballombe@debian.org>, 583756@bugs.debian.org
Subject: Re: Bug#583756: desktopnova: circular dependency with desktopnova-module-gnome|desktopnova-module-xfce
Date: Sun, 30 May 2010 16:02:57 +0200
Hi Bill,

On Sunday 30 May 2010 14:50:36 Bill Allombert wrote:
> There is a circular dependency between desktopnova,
> desktopnova-module-gnome and desktopnova-module-xfce:
>
> [...] 
> 
> Circular dependencies, especially with exact version requirement are known
> to cause problems during upgrade, so we should try to get rid of them.
> 
> See threads
> http://lists.debian.org/debian-devel/2005/06/msg02111.html
> http://lists.debian.org/debian-devel/2005/11/msg01101.html

Thank you for pointing out this issue. I’d like to fix this bug as soon as
possible, but at the moment I don’t know the correct way. After reading the
mailing list threads I still have a few open questions.

I try to explain it in detail:

The main package “desktopnova” provides only the user interface and the
background daemon. The daemon uses modules (plugins) which contain the 
features the user expects. These modules are packaged as
“desktopnova-modules-*”. Before the modules are fully loaded, the version of
the main program and the modules are checked. If they’re not equal, the module
is discarded.

Now I think that neither the main package nor the modules should depend on
each other. No error will be raised if the main program has no modules or the
modules are installed without the main package. But if the main package is
installed, the version must (ok, should -- no error will be raised either) be 
equal to the version of the installed modules.

I would express this as the following dependency:


desktopnova recommends desktopnova-module-*
desktopnova conflicts with desktopnova-module-* (!= $version)

desktopnova-module-* recommends desktopnova
desktopnova-module-* conflicts with desktopnova-* (!= $version)


Could you tell me if this is the correct way to go? Is there any problem with 
the circular recommendation? (no explicit version given)

Please be patient. This was my first package for Debian, but I’m willing to 
learn more about how to make my packages better. :)


Regards,
Stefan




Information forwarded to debian-bugs-dist@lists.debian.org, Stefan Haller <haliner@googlemail.com>:
Bug#583756; Package desktopnova. (Sun, 30 May 2010 15:39:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Stefan Haller <haliner@googlemail.com>. (Sun, 30 May 2010 15:39:08 GMT) Full text and rfc822 format available.

Message #15 received at 583756@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Stefan Haller <haliner@googlemail.com>
Cc: 583756@bugs.debian.org
Subject: Re: Bug#583756: desktopnova: circular dependency with desktopnova-module-gnome|desktopnova-module-xfce
Date: Sun, 30 May 2010 17:35:54 +0200
On Sun, May 30, 2010 at 04:02:57PM +0200, Stefan Haller wrote:
> Hi Bill,
> 
> I try to explain it in detail:
> 
> The main package “desktopnova” provides only the user interface and the
> background daemon. The daemon uses modules (plugins) which contain the 
> features the user expects. These modules are packaged as
> “desktopnova-modules-*”. Before the modules are fully loaded, the version of
> the main program and the modules are checked. If they’re not equal, the module
> is discarded.
> 
> Now I think that neither the main package nor the modules should depend on
> each other. No error will be raised if the main program has no modules or the
> modules are installed without the main package. But if the main package is
> installed, the version must (ok, should -- no error will be raised either) be 
> equal to the version of the installed modules.
> 
> I would express this as the following dependency:
> 
> 
> desktopnova recommends desktopnova-module-*
> desktopnova conflicts with desktopnova-module-* (!= $version)
> 
> desktopnova-module-* recommends desktopnova
> desktopnova-module-* conflicts with desktopnova-* (!= $version)
> 
> Could you tell me if this is the correct way to go? Is there any problem with 
> the circular recommendation? (no explicit version given)

Hello Stephan,

Circular Recommends do not cause issues, since it is allowed to break
Recommends

From the information you give, I would suggest:
desktopnova-module-* Depends desktopnova (=$version)
desktopnova Recommends desktopnova-module-gnome|desktopnova-module-xfce

Conflicts should be avoided.

Generally you should first consider the dependencies before naming and
splitting yours packages. The key are what is the primary package from
an user point of vue.
From the information you give, I expect that a user either run GNOME or
XFCE, so will want to install either desktopnova-module-gnome or
desktopnova-module-xfce, but never desktopnova alone, so desktopnova-module-*
are the primary packages. So according to this theory I would have named them
desktopnova-gnome and desktopnova-xfce, and desktopnova would have been
named desktopnova-common.

Cheers,
Bill.




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#583756; Package desktopnova. (Sun, 30 May 2010 16:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stefan Haller <haliner@googlemail.com>:
Extra info received and forwarded to list. (Sun, 30 May 2010 16:03:03 GMT) Full text and rfc822 format available.

Message #20 received at 583756@bugs.debian.org (full text, mbox):

From: Stefan Haller <haliner@googlemail.com>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: 583756@bugs.debian.org
Subject: Re: Bug#583756: desktopnova: circular dependency with desktopnova-module-gnome|desktopnova-module-xfce
Date: Sun, 30 May 2010 17:58:44 +0200
Thanks for your fast response.

On Sunday 30 May 2010 17:35:54 Bill Allombert wrote:
> Circular Recommends do not cause issues, since it is allowed to break
> Recommends

Great, I’ll keep it in mind.
 
> From the information you give, I would suggest:
> desktopnova-module-* Depends desktopnova (=$version)
> desktopnova Recommends desktopnova-module-gnome|desktopnova-module-xfce
> 
> Conflicts should be avoided.

Sounds good. I will implement the proposal.

> Generally you should first consider the dependencies before naming and
> splitting yours packages. The key are what is the primary package from
> an user point of vue.
> From the information you give, I expect that a user either run GNOME or
> XFCE, so will want to install either desktopnova-module-gnome or
> desktopnova-module-xfce, but never desktopnova alone, so
> desktopnova-module-* are the primary packages. So according to this theory
> I would have named them desktopnova-gnome and desktopnova-xfce, and
> desktopnova would have been named desktopnova-common.

Oh, that’s a good point. Another thing I wasn’t aware of...


Regards,
Stefan




Reply sent to Stefan Haller <haliner@googlemail.com>:
You have taken responsibility. (Sun, 27 Jun 2010 16:54:05 GMT) Full text and rfc822 format available.

Notification sent to Bill Allombert <ballombe@debian.org>:
Bug acknowledged by developer. (Sun, 27 Jun 2010 16:54:05 GMT) Full text and rfc822 format available.

Message #25 received at 583756-close@bugs.debian.org (full text, mbox):

From: Stefan Haller <haliner@googlemail.com>
To: 583756-close@bugs.debian.org
Subject: Bug#583756: fixed in desktopnova 0.8-2
Date: Sun, 27 Jun 2010 16:50:27 +0000
Source: desktopnova
Source-Version: 0.8-2

We believe that the bug you reported is fixed in the latest version of
desktopnova, which is due to be installed in the Debian FTP archive:

desktopnova-module-gnome_0.8-2_amd64.deb
  to main/d/desktopnova/desktopnova-module-gnome_0.8-2_amd64.deb
desktopnova-module-xfce_0.8-2_amd64.deb
  to main/d/desktopnova/desktopnova-module-xfce_0.8-2_amd64.deb
desktopnova-tray_0.8-2_amd64.deb
  to main/d/desktopnova/desktopnova-tray_0.8-2_amd64.deb
desktopnova_0.8-2.debian.tar.gz
  to main/d/desktopnova/desktopnova_0.8-2.debian.tar.gz
desktopnova_0.8-2.dsc
  to main/d/desktopnova/desktopnova_0.8-2.dsc
desktopnova_0.8-2_amd64.deb
  to main/d/desktopnova/desktopnova_0.8-2_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 583756@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Stefan Haller <haliner@googlemail.com> (supplier of updated desktopnova package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 19 Jun 2010 13:07:46 +0200
Source: desktopnova
Binary: desktopnova desktopnova-module-gnome desktopnova-module-xfce desktopnova-tray
Architecture: source amd64
Version: 0.8-2
Distribution: unstable
Urgency: low
Maintainer: Stefan Haller <haliner@googlemail.com>
Changed-By: Stefan Haller <haliner@googlemail.com>
Description: 
 desktopnova - utility that changes the wallpaper automatically
 desktopnova-module-gnome - GNOME module for DesktopNova
 desktopnova-module-xfce - Xfce module for DesktopNova
 desktopnova-tray - tray icon for DesktopNova
Closes: 583756
Changes: 
 desktopnova (0.8-2) unstable; urgency=low
 .
   * Avoid circular dependencies. (Closes: #583756)
   * Mention copyright of translation explicitly.
Checksums-Sha1: 
 59e1098b0c02fdb32d363d67d6748e1fa39e889a 1216 desktopnova_0.8-2.dsc
 812c776098c7a12b884d59a7627192c72421930e 2357 desktopnova_0.8-2.debian.tar.gz
 029f26072a6448fbd881c81f3f49e554368e514e 86356 desktopnova_0.8-2_amd64.deb
 7c2c130b1a2e6ceb667e2a8c2aee7c54b35fd828 8896 desktopnova-module-gnome_0.8-2_amd64.deb
 6bef1bc60973e2a6b6224daf0d37e9d8426ede66 15158 desktopnova-module-xfce_0.8-2_amd64.deb
 120b3e55f502a8b604876221529e124e6a8e3628 23352 desktopnova-tray_0.8-2_amd64.deb
Checksums-Sha256: 
 6169cb0a0c40f417916af93940910c36ce80edacdcf612a41216914b220e188b 1216 desktopnova_0.8-2.dsc
 4b91a4aa6e54677a48c3cb34790bfb42e714d88f979d5b94f5660b08685a6f10 2357 desktopnova_0.8-2.debian.tar.gz
 373acea9dc19f4ed789975f45f69d898f63e93fd31e71fe520dd50962c393212 86356 desktopnova_0.8-2_amd64.deb
 d91ce878ae1a814bdd971e8320ac44b085b767f51938e79fd9a0abc28843a327 8896 desktopnova-module-gnome_0.8-2_amd64.deb
 90b8e86a9386494dc09b74b629df6beced2b4b3242667aa7d82461c735a45638 15158 desktopnova-module-xfce_0.8-2_amd64.deb
 b72199985ade383464b3d8e1e492964fc308b135fdfd8b946455ace7d8a1c13f 23352 desktopnova-tray_0.8-2_amd64.deb
Files: 
 c9397d9fde65d87f77a4115787272312 1216 misc optional desktopnova_0.8-2.dsc
 95356a8af4b2c5e081113b08169df461 2357 misc optional desktopnova_0.8-2.debian.tar.gz
 a517eb72293c718e5c1a5194f3e82d43 86356 misc optional desktopnova_0.8-2_amd64.deb
 8f4a8413515ba789d70dca866881d421 8896 misc optional desktopnova-module-gnome_0.8-2_amd64.deb
 3c529b654b65c1e1851e00177e61d0eb 15158 misc optional desktopnova-module-xfce_0.8-2_amd64.deb
 adfaf4f2d8e128d48d441ba678c699d3 23352 misc optional desktopnova-tray_0.8-2_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkwnf3MACgkQMDatjqUaT90p2wCfVq9R5/KBcAFFGf3zDbe9Hl6Y
uigAoKwEw91JqQWyqF7uUDwLqNoeU+ca
=zjJV
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 05 Aug 2010 07:39:34 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 21:06:20 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.